Subject: Re: Re[2]: [PATCH 05/19] netfilter: nf_conntrack_ipv6: improve fragmentation handling

From: Jesper Dangaard Brouer <[email-masked]>
Date: Thu, 23 Aug 2012 16:49:20 +0200

On Wed, 2012-08-22 at 10:16 +0300, Julian Anastasov wrote:
> 	Hello,
> 
> On Wed, 22 Aug 2012, Julian Anastasov wrote:
> 
> > On Wed, 22 Aug 2012, Hans Schillstrom wrote:
> > 
> > > >Perhaps we could change/fix the MTU check in IPVS?
> > > >(This would also solve issues I've seen with TSO/GSO frames, hitting
> > > >this code path).
> > > >
> > > I ran into this as well, 
> > > try this for the mtu check.
> > > 
> > >        if ((!skb->local_df && skb->len > mtu && !skb_is_gso(skb)) ||
> > >            (IP6CB(skb)->frag_max_size && IP6CB(skb)->frag_max_size > mtu)) {
> > 
> > 	Better without local_df check, it is our job to
> > set it.

Will the IPVS usage of local_df, conflict with Patrick's usage?

> 	Ops, sorry. It seems now nf_ct_frag6_reasm (Patch 02/18)
> will set head->local_df = 1, so we should check local_df
> as Hans said.

With Hans'es version of the MTU check, IPVS seems to work again (with
Patricks patches applied).

(Also spotted the GSO problem I had with IPv6 + DR, and send an upstream
fix...)

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Sr. Network Kernel Developer at Red Hat
  Author of http://www.iptv-analyzer.org
  LinkedIn: http://www.linkedin.com/in/brouer